#!/bin/csh -f

set path = (/Volumes/CARVE/tools-src $path)
if ($#argv == 0) then
	echo "Usage: prefix data-set-path"
	exit 0
endif
set prefix = $1
set dir = $2
set suffix = `date +_%y%m%d%H%M`
set img = /tmp/$prefix-basic$suffix.dd
set log = /tmp/$prefix-basic$suffix-log.txt
set dlist = (`ls /tmp | grep $prefix-basic`)
#if (-e $img) /bin/rm $img
if ($#dlist > 0) then
	echo "Delete $dlist"
	foreach f ($dlist)
		/bin/rm /tmp/$f
	end
endif
touch $log

# set fillers
set fill_dir = "/Volumes/CARVE/filler/"
set fill_files = (`ls /Volumes/CARVE/filler | grep -v profile`)
#
foreach file ($fill_files)
	if (-e /tmp/$file) /bin/rm /tmp/$file
	cp ${fill_dir}$file /tmp/$file
	cat ${fill_dir}$file ${fill_dir}$file ${fill_dir}$file >> /tmp/$file
	cat ${fill_dir}$file ${fill_dir}$file ${fill_dir}$file >> /tmp/$file
	cat ${fill_dir}$file >> /tmp/$file
end


dd bs=512 count=1 if=/dev/zero of=$img >& /dev/null


@ cnt = 0
set size_list = (0 1 2 4 8 16 32 64 128)
set fill_list = ($fill_files)
set f_list = (`ls $dir | egrep -v '(\.txt)|(\.csh)|(\.dd)'`)
echo "Fill: " $fill_list >> $log
echo "=======================" >> $log
echo "Files: " $f_list >> $log
echo "=======================" >> $log
foreach fx ($f_list)

	set file = $dir/$fx
	@ ix = ($cnt % $#size_list) + 1
	@ jx = ($cnt % $#fill_list) + 1

#	echo "$file fill size $size_list[$ix], fill content $fill_list[$jx]" >> $log
	echo "$fx followed by $size_list[$ix] sectors of $fill_list[$jx]" >> $log
	block-cat.py $file >> $img
	(dd if=/tmp/$fill_list[$jx] bs=512 count=$size_list[$ix] >> $img) >& /dev/null

	@ cnt = $cnt + 1
end
