#!/bin/csh -f

set path = (/Volumes/CARVE/tools-src $path)


if ($#argv != 2) then
	echo "Usage: prefix data-set-path"
	exit 0
endif
set prefix = $1
set dir = $2
set suffix = `date +_%y%m%d%H%M`
set root = braid
set img = /tmp/$prefix-$root$suffix.dd
set log = /tmp/$prefix-$root$suffix-log.txt

set dlist = (`ls /tmp | grep $prefix-$root`)
if ($#dlist > 0) then
	echo "Delete $dlist"
	foreach f ($dlist)
		/bin/rm /tmp/$f
	end
endif
touch $log

# set fillers
set fill_dir = "/Volumes/CARVE/filler/"
set fill_files = (`ls /Volumes/CARVE/filler | grep -v profile`)
#
foreach file ($fill_files)
	if (-e /tmp/$file) /bin/rm /tmp/$file
	cp ${fill_dir}$file /tmp/$file
	cat ${fill_dir}$file ${fill_dir}$file ${fill_dir}$file >> /tmp/$file
	cat ${fill_dir}$file ${fill_dir}$file ${fill_dir}$file >> /tmp/$file
	cat ${fill_dir}$file >> /tmp/$file
end

dd bs=512 count=1 if=/dev/zero of=$img >& /dev/null


set size_list = (0 1 2 4 8 16 32 64 128)
set fill_list = ($fill_files)
set exts_avail = (`/bin/ls $dir | sed -e 's/.*\.//' | tr '[A-Z]' '[a-z]' | sort -u | egrep -v '(txt)|(csh)|(dd)'`)
echo "Fill: " $fill_list >> $log
echo "=======================" >> $log
echo "Extensions: " $exts_avail >> $log
foreach xxx ($exts_avail)
@ f_cnt = `ls $dir | grep -i "\.$xxx" | wc -l`
if ($f_cnt < 20) then
set f_list = (`ls $dir | grep -i "\.$xxx" | head -4`)
else
	@ t_cnt = ($f_cnt / 2) + 9
set f_list = (`ls $dir | grep -i "\.$xxx" | tail -${t_cnt} | head -4`)
endif
echo "=======================" >> $log
echo "Files: " $f_list >> $log
echo "=======================" >> $log
set fa = $dir/$f_list[1]
set fb = $dir/$f_list[2]
set fc = $dir/$f_list[3]
set fd = $dir/$f_list[4]
@ cnt = 0
	if (-e /tmp/whole.dd) /bin/rm /tmp/whole.dd
	@ ix = ($cnt % $#size_list) + 1
	@ jx = ($cnt % $#fill_list) + 1
	@ omit = $cnt % 6
	@ z = `ls -s $fb | sed 's/ .*//'`
	@ zc = `ls -s $fc | sed 's/ .*//'`
	@ delta = $z / 3
	@ deltac = $zc / 3
		block-cat.py $fb > /tmp/b-file.dd
		block-cat.py $fc > /tmp/c-file.dd

		block-cat.py $fa >> $img
		(dd if=/tmp/b-file.dd count=$delta bs=512 >> $img) >& /dev/null
		(dd if=/tmp/c-file.dd count=$deltac bs=512 >> $img) >& /dev/null
		(dd if=/tmp/b-file.dd skip=$delta bs=512 >> $img) >& /dev/null
		(dd if=/tmp/c-file.dd skip=$deltac bs=512 >> $img) >& /dev/null
		block-cat.py $fd >> $img
		echo "File $f_list[1]" >> $log
		echo "First $delta sectors of $f_list[2]" >> $log
		echo "First $deltac sectors of $f_list[3]" >> $log
		echo "Remaining sectors of $f_list[2]" >> $log
		echo "Remaining sectors of $f_list[3]" >> $log
		echo "File $f_list[4]" >> $log

end
