#!/bin/csh -f

# run eval-all on all tools sets
#
#
#	usage: eval-all.csh pic-dir dd-dir result-parent-dir
#
#
#	
#        eval-result.csh tool-name-and-version pic-dir dd-file result-dir
#        the output of profile-result.py & run-image-profile.csh and
				        

set cur_rel = `sed < current_rel.py -e 's/.*= //' | tr -d "'"`
echo "%Z% %M% Version %I% created %G% at %U% (Release $cur_rel)"

if ($#argv != 3) then
	echo "Usage: $0 data-set-dir image-dir result-dir"
	exit (0)
endif

set data_dir = $1
if $data_dir:t == "" then
	set data_dir = $data_dir:h
endif

set image_dir = $2
if $image_dir:t == "" then
	set image_dir = $image_dir:h
endif

set parent_dir = $3
if $image_dir:t == "" then
	set parent_dir = $parent_dir:h
endif

if (!(-d $image_dir))then
	echo "$image_dir does not exist"
	exit (1)
endif

if (!(-d $data_dir))then
	echo "$data_dir does not exist"
	exit (1)
endif

if (!(-d $parent_dir))then
	echo "$parent_dir does not exist"
	exit (1)
endif

echo "Data: $data_dir"
echo "Image: $image_dir"
echo "Parent: $parent_dir"

set try_list = `ls $parent_dir`
foreach tr ($try_list)
	if (-d $parent_dir/$tr) then
		echo try $tr
		eval-all.csh $data_dir $image_dir $parent_dir/$tr
	else
		echo skip $tr
	endif
end
