#!/usr/bin/python
# -*- coding: utf-8 -*-
import hashlib
import sys
import os
import current_rel

ver = "%Z% %M% Version %I% created %G% at %U%"+" (Release %s)"%(current_rel.this_rel_is)

class r_rec (object):
	def __str__ (s):
		return 'File:%s <%d,%d> @ LBA %d'%(s.file,s.begin,s.end,s.offset)
	def __init__ (s,rnr,returned,relevant):
		s.rnr = rnr # returned and relevant
		s.returned = returned # number returned
		s.relevant = relevant # number relevant
	def inc (s,rnr,returned,relevant):
		s.rnr += rnr # returned and relevant
		s.returned += returned # number returned
		s.relevant += relevant # number relevant

totals = {}

for line in sys.stdin:
	fields = line.split(';')
	if len(fields) != 7: continue
	if not (fields[1].strip() +fields[2].strip()
		+fields[4].strip()).isdigit(): continue
	rnr = int(fields[1])
	ret = int(fields[2])
	rel = int(fields[4])
	x = fields[0]
	if x in totals:
		totals[x].inc(rnr,ret,rel)
	else:
		totals[x] = r_rec(rnr,ret,rel)
for x in totals:
	p = 0.0
	r = 0.0
	if totals[x].returned != 0:
		r = float(totals[x].rnr)/float(totals[x].returned)
	if totals[x].relevant != 0:
		p = float(totals[x].rnr)/float(totals[x].relevant)
	f = 0.0
	if totals[x].returned == 0 or totals[x].relevant == 0: f = 0.0
	else:
		if totals[x].rnr == 0: f = 0.0
		else: f = 2.0*(p*r)/(p+r)
#	print x,totals[x].rnr,totals[x].returned,totals[x].relevant
	print "%s;%d;%d;%.3f;%d;%.3f;%.3f"%(x,totals[x].rnr,totals[x].returned,r,
		totals[x].relevant,p,f)

#Relevant and Recovered Data scores Summary by Extension
#Test Case;Recovered and Relevant;Recovered;P;Relevant;R;F

