#!/bin/csh -f

# run eval-result on all result sets
#
#
#	usage: eval-all.csh pic-dir dd-dir result-parent-dir
#
#
#	
#        eval-result.csh tool-name-and-version pic-dir dd-file result-dir
#        the output of profile-result.py & run-image-profile.csh and
				        


if ($#argv != 3) then
	echo "Usage: $0 data-set-dir image-dir result-dir"
	exit (0)
endif

set data_dir = $1
if $data_dir:t == "" then
	set data_dir = $data_dir:h
endif

set image_dir = $2
if $image_dir:t == "" then
	set image_dir = $image_dir:h
endif

set parent_dir = $3
if $image_dir:t == "" then
	set parent_dir = $parent_dir:h
endif

if (!(-d $image_dir))then
	echo "$image_dir does not exist"
	exit (1)
endif

if (!(-d $data_dir))then
	echo "$data_dir does not exist"
	exit (1)
endif

if (!(-d $parent_dir))then
	echo "$parent_dir does not exist"
	exit (1)
endif

echo "Data: $data_dir"
echo "Image: $image_dir"
echo "Parent: $parent_dir"

set tool_version = (`cat $parent_dir/toolname.txt | tr ' ' '_'`)
set tool_name = $tool_version
set result_file_name = result-${tool_name}.txt
echo "Tool: $tool_name"
set dd_list = `ls $image_dir | grep '\.dd'`
echo "DD: $dd_list"
set test_list = `ls $parent_dir | grep '[_-]'`
if (-e /tmp/$result_file_name) /bin/rm /tmp/$result_file_name
if (-e /tmp/err.txt) /bin/rm /tmp/err.txt
if (!(-e /tmp/carve-ad)) mkdir /tmp/carve-ad
touch /tmp/$result_file_name
touch /tmp/err.txt
touch /tmp/Analysis.txt /tmp/Detail.txt
/bin/rm /tmp/Analysis*txt /tmp/Detail*txt
echo "test list: [$test_list]" >> /tmp/err.txt
echo "<start-table>" > /tmp/r-and-r.txt
echo "Relevant and Recovered Data scores Summary for $tool_name" >> /tmp/r-and-r.txt
echo "Test Case;Recovered and Relevant;Recovered;P;Relevant;R;F" >> /tmp/r-and-r.txt
#r_n_r.write("<start-table>"+'\n')
#r_n_r.write("Relevant and Recovered Data scores Summary"+'\n')
#r_n_r.write("Test Case;Recovered and Relevant;Recovered;P;Relevant;R;F"+'\n')
foreach td ($test_list)
	set dd = `echo $dd_list | tr ' ' '\n' | grep $td`
	echo "Test $td against $dd"
	echo "Test ($td) against ($dd)" >> /tmp/err.txt
#        eval-result.csh tool-name-and-version pic-dir dd-file result-dir
	if ((-e $image_dir/$dd) && ($dd != "")) then
		echo "Processing $td" >> /tmp/err.txt
		eval-result.csh $tool_name $data_dir $image_dir/$dd $parent_dir/$td
		cat /tmp/Analysis*txt /tmp/Detail*txt >> /tmp/$result_file_name
	else
		echo "No $td found" >> /tmp/err.txt
	endif
#	ls -lt /tmp/*.txt
	mv /tmp/Analysis*txt /tmp/Detail*txt /tmp/carve-ad
end
echo "<end-table>" >> /tmp/r-and-r.txt
echo "<start-head>Relevant and Recovered Data scores Summary<end-head>" \
	>> /tmp/$result_file_name
echo	>> /tmp/$result_file_name
cat /tmp/r-and-r.txt >> /tmp/$result_file_name
grep '^...;.*;.*;.*;.*;.*;' /tmp/$result_file_name | sort > /tmp/pr-by-ext.txt
echo >> /tmp/$result_file_name
echo "<start-table>" >> /tmp/$result_file_name
echo "Relevant and Recovered Data scores Summary for $tool_name by Extension" \
	>> /tmp/$result_file_name
echo "Test Case;Recovered and Relevant;Recovered;P;Relevant;R;F" >> /tmp/$result_file_name
compute-rnr-by-ext.py < /tmp/pr-by-ext.txt >> /tmp/$result_file_name
echo "<end-table>" >> /tmp/$result_file_name
