#!/bin/csh -f

# Create an image profile
#
# input is a data-set-profile and an image-file
#
#	usage: prep-data-set.csh data-set-dir image-file
#
#	output: one file -- image-profile
#
#echo "@(#) run-image-scan.csh Version 1.4 created 06/07/13 at 10:09:02"
set cur_rel = `sed < current_rel.py -e 's/.*= //' | tr -d "'"`
echo "@(#) run-image-scan.csh Version 1.4 created 06/07/13 at 10:09:02 (Release $cur_rel)"

if ($#argv != 2) then
	echo "Usage: $0 data-set-dir image_file.dd"
	exit (0)
endif

set dir = $1
set img = $2
if ( !(-d $dir)) then
	echo $dir " is not a directory"
	exit(1)
endif

#ls $dir
if $dir:t == "" then
	set dir = $dir:h
endif

set p_file = $dir/$dir:t-profile.txt
set t_file = $dir/$dir:t-thumbs.txt
set i_file = $dir/$img:r:t-ip.txt

#profile-image.py $p_file $img > $i_file
#scan-image.py $p_file $t_file $img >& /tmp/image-scan-debug.txt
scan-image.py $p_file $t_file $img > $i_file
echo "Image profile ($i_file) created for $img"
