#!/bin/csh -f

# run image scan on all images
#
#
#	usage: scan-all.csh data-set-dir image-dir
#
#


if ($#argv != 2) then
	echo "Usage: $0 data-set-dir image-dir"
	exit (0)
endif

set dir = $1
if $dir:t == "" then
	set dir = $dir:h
endif

set image_dir = $2
if $image_dir:t == "" then
	set image_dir = $image_dir:h
endif

if (!(-d $image_dir))then
	echo "$dir does not exist"
	exit (1)
endif

if (!(-d $dir))then
	echo "$dir does not exist"
	exit (1)
endif
set zlist = (`ls $image_dir | grep "\.dd"`)
foreach x ($zlist)
	echo "run-image-scan.csh $dir $image_dir/$x"
	run-image-scan.csh $dir $image_dir/$x
end
set shifted_list = `ls $dir/*-ip.txt | grep shift`
echo "Shifted ($#shifted_list): $shifted_list"
if ($#shifted_list == 2) then
	mv $shifted_list[2] /tmp
	sed -e '/shifted/s/not//g' < $shifted_list[1] > $shifted_list[2]
endif
#run-image-scan.csh ../graphic-src ../images/graphic-basic_1305121231.dd
