#!/usr/bin/python
# -*- coding: utf-8 -*-
import hashlib
import sys
import os
import current_rel

#	input: data-set-profile.txt thumb-profile.txt image_file.dd

#	generate a profile of an image file
#	output: 
#

# sample input	

#	Summary bn.xxx 10 blocks 5120 bytes
#	Summary lav.xxx 10 blocks 5120 bytes
#	Summary rr.xxx 6 blocks 2925 bytes
#	Summary white.xxx 10 blocks 5120 bytes
#	Summary yellow.xxx 10 blocks 5120 bytes
#	Start File bn.xxx
#	H 0 28642ba995bfd672d3c0ff159dd7b26f
#	. . .
#	H 8 76b3c06f5be8b265b5da653de9be703d
#	H 9 6d59537db71f60e6493a38533f89b9ed
#	End File yellow.xxx
#	Common 1
#	CH d9e05b1d25f1e29e65de31001feba0be 0
#	CF 0 bn.xxx 5
#	CF 0 lav.xxx 5
#	CF 0 white.xxx 5
#	CF 0 yellow.xxx 5
#	tail
#	T 204afb3ac88334fb6a56d64b2ab7c22a rr.xxx 5
#	V @(#) scan-image.py Version 1.6 created 11/18/13 at 10:04:14

class t_rec (object): # thumb location in sector offset
	def __init__ (s,begin,end):
		s.begin = int(begin)/512
		s.end = (int(end)+511)/512

class chunk (object):
	def __init__ (s,file,lba,begin,end):
		s.file = file
		s.lba = lba
		s.begin = begin
		s.end = end

class common_hit(object):
	def __init__ (s,lba,hash):
		s.lba = lba
		s.hash = hash
	def __str__ (s):
		return '** lba:'+str(s.lba)+' MD5: '+s.hash+' **'

class hit(object):
	def __init__ (s,file,blk):
		s.file = file
		s.block = blk

class summary(object):
	def __init__ (s,file,n):
		s.file = file
		s.n_blocks = n

class file_frag(object):
	def __init__ (s,file,size,n,n_frags):
		s.file = file
		s.size = size
		s.n_blocks = n
		s.n_frags = n_frags

def frag_sort (a,b):
	aa = a.file.split('.')[1].lower()
	bb = b.file.split('.')[1].lower()
	if aa < bb: return -1
	if aa > bb: return  1
	if a.file < b.file: return -1
	if a.file > b.file: return  1
	if a.begin < b.begin: return -1
	if a.begin > b.begin: return  1
	return 0

def is_fit(ten,elist):
	for next in elist:
		if ten.file == next.file:
			if ((ten.end + 1) == int(next.block)): return True
	return False

# count thumbs within a fragment
def count_thumbs (fbegin,fend,tlist):
	cnt = 0
#	print "searching between <%d -- %d>"%(fbegin,fend)
	for t in tlist:
#		print "\tTry [%d,%d]"%(t.begin,t.end)
		if t.begin >= fbegin and t.end <= fend: cnt += 1
	return cnt


def fn_sort (a,b):
	aa = a.split('.')
	bb = b.split('.')
	if aa[1].lower() < bb[1].lower(): return -1
	if aa[1].lower() > bb[1].lower(): return  1
	if aa[0].lower() < bb[0].lower(): return -1
	if aa[0].lower() > bb[0].lower(): return  1
	return 0

#file_name_list.sort(cmp=fn_sort)

def delta_one (attr,ext):
	if ext in attr:
		attr[ext] += 1
	else:
		attr[ext] = 1

xn_c = {}
xn_cnc = {}
xn_cnf = {}
xn_disorder = {}
xn_fx = {}
xn_partial = {}
xn_frag = {}
xn_start = {}
xn_end = {}
xn_thumb = {}

attr_list = [xn_c,xn_cnc,xn_cnf,xn_disorder, xn_partial, xn_fx,
	xn_frag, xn_thumb, xn_start, xn_end]

#
#	see if files exist
#	argv[1] is set of file profiles
#	argv[3] is the image file
#
#ver = "@(#) scan-image.py Version 1.6 created 11/18/13 at 10:04:14"
ver = "@(#) scan-image.py Version 1.6 created 11/18/13 at 10:04:14"+" (Release %s)"%(current_rel.this_rel_is)

print
print ver

if len(sys.argv) != 4:
	print "%s %d args, need: file-profiles image-file"%(sys.argv[0],len(sys.argv) - 1)
	exit (1)
if os.access(sys.argv[1],os.F_OK) == False:
	print sys.argv[1],"does not exist"
	exit(0)
if os.access(sys.argv[2],os.F_OK) == False:
	print sys.argv[2],"does not exist"
	exit(0)
if os.access(sys.argv[3],os.F_OK) == False:
	print sys.argv[3],"does not exist"
	exit(0)

# OK, files exist
#print "%d Files Present in %s;;;;;"%(len(fx),sys.argv[3].split('/')[-1])
image_name = sys.argv[3].split('/')[-1]
short_name = image_name.split('_')[0]
data_set_name = sys.argv[1].split('/')[-2]
#print "args",sys.argv
#print "dsn",data_set_name
print "<start-head>Image %s<end-head>\n"%(image_name)
print "Image: %s\nData Set: %s\n"%(image_name,data_set_name)
#print "Image: %s\nData Set: %s\n"%(sys.argv[3].split('/')[-1],sys.argv[1].split('/')[-2])
bs = 512
files_seen = set()
hashes = {}
tail_hashes = {}
file_summary = {}
db = open(sys.argv[1],"rt")
#
# read the file profiles
#
for line in db:
	line = line.strip('\n')
	fields = line.split(' ')
#	print fields
	if fields[0] == "Summary":
		fn = fields[1]
		blks = fields[2]
		file_summary[fn] = blks
#
#	start of a file
#
	elif fields[0] == "Start":
		current_file = fields[2]
	elif fields[0] == "H":
		h = fields[2]
		blk = fields[1]
		entry = hit(current_file,blk)
		if h in hashes:
			hashes[h].append(entry)
		else:
			hashes[h] = [entry]
	elif fields[0] == "CH":
		pass
	elif fields[0] == "CF":
		pass
	elif fields[0] == "T":
		h = fields[1]
		blk = fields[3]
		tail_name = fields[2]
		entry = hit(tail_name,blk)
		if h in tail_hashes:
			tail_hashes[h].append(entry)
		else:
			tail_hashes[h] = [entry]
	else :
		pass
#
# file profiles loaded
#

#print "Hashes"
#for h in hashes:
#	elist = hashes[h]
#	for e in elist:
#		print e.file,e.block,h
#print "Tails"
#for tail in tail_hashes:
#	print tail_hashes[tail].file,tail_hashes[tail].block

tcount = {}
t_loc = {}
tdb = open (sys.argv[2],"rb")
for line in tdb:
	tf = line.strip('\n').split(' ')
	if tf[0] == 'XT':
		tcount[tf[1].split('/')[-1]] = tf[2]
	elif tf[0] == "Thumb":
		tfile = tf[3].split('/')[-1]

		# need to extract tbegin(xxx):tend(yyy)
		tentry = tf[6]
		tbegin = tentry.split('(')[0]
		tend = tentry.split(':')[1].split('(')[0]
#		print "extract t-limits <%s> <%s> <%s>"%(tentry,tbegin,tend)
		if tfile in t_loc:
			t_loc[tfile].append(t_rec(tbegin,tend))
		else:
			t_loc[tfile] = [t_rec(tbegin,tend)]
#for tx in t_loc:
#	print tx,
#	for tz in t_loc[tx]:
#		print ",[%d,%d]"%(tz.begin,tz.end),
#	print
#for tx in tcount:
#	print tx,';',tcount[tx]

f = open (sys.argv[3],"rb")
block = f.read(bs)
chunks = []
# a chunk is a list of chunks seen: (file_name, first_block,last_block)
lba = 0
from_lba = 0
print
print "<start-subhead>Image Profile for %s<end-subhead>\n"%(short_name)
print "<start-table>"
print ";Image Profile for:",sys.argv[3].split('/')[-1],';'
print "LBA;Length;LBA-End;Content;First;Last"
#print "LBA;Length;End;Content;First;Length;Last"
#
# scan the image
#
frag_list = []
in_common_run = False
in_filler = False
active = False
while len(block) > 0:
	m = hashlib.md5()
	m.update(block)
	h = m.hexdigest()
	is_hash = h in hashes
#	if not is_hash:
#		print "LBA: %d Hash: %s"%(lba,h)
#	print "LBA:",lba,"active",active,"In Filler",in_filler,"In hash",is_hash
	if h in hashes:
		if len(hashes[h]) == 1:
			files_seen.add(hashes[h][0].file)
		if active:  # there is an active tentative chunk
			current = chunk(hashes[h][0].file,
					lba,
					int(hashes[h][0].block),
					int(hashes[h][0].block))
			ok = is_fit (t,hashes[h])
			if ok:
				t.end += 1
			else:
#				print "Chunk: %s at lba %d blocks %d - %d"%(t.file,t.lba,t.begin,t.end)
#				print "%d;%d;%d;%s;%d;%d;%d"%(t.lba,t.end+1-t.begin,t.lba-t.begin+t.end,t.file,t.begin,
#					t.end+1-t.begin,t.end)
				print "%d;%d;%d;%s;%d;%d"%(t.lba,t.end+1-t.begin,
					t.lba-t.begin+t.end,t.file,t.begin,t.end)
				frag_list.append(t)
				if len(hashes[h]) == 1:
					t = current
				else:
					active = False
					in_common_run = True
					common_run = [common_hit(lba,h)]
		else:  # there is no tentative chunk
			if in_filler:
				in_filler = False
#				print "Filler: at lba %d, %d blocks"%(filler_lba,k_filler)
				print "%d;%d;%d;Filler;;"%(filler_lba,k_filler,filler_lba - 1 + k_filler)
			if len(hashes[h]) == 1:
				t = chunk(hashes[h][0].file,
						lba,
						int(hashes[h][0].block),
						int(hashes[h][0].block))
				active = True
				if in_common_run:
#					print "Active common run"
					in_common_run = False
#					print "need: ",t.file,t.begin-1
					need_block = t.begin
					ix = len(common_run)
					n_match = 0
					while ix > 0:
						ix -= 1
						need_block -= 1
						x = common_run[ix]
						for z in hashes[x.hash]:
							if (z.file == t.file) and (int(z.block) == need_block):
								n_match += 1
#								print "match",t.file,need_block
#					for x in common_run:
#						print x.lba,x.hash,
#						for z in hashes[x.hash]:
#							print "(",z.file,z.block,")",
#						print 
#					print n_match,"common blocks match"
					if len(common_run) == n_match: # merge common blocks into tentative
						t.lba -= n_match
						t.begin -= n_match
					else : # unrecognized common blocks
						pass
						# n_common may be zero!
#						print common_run[0],"******** TRACE"
#						print "Types: ",type(common_run[0].lba)
						print "%s;%d;%d;Ambigious;;"%(common_run[0].lba,len(common_run),
							(common_run[0].lba) - 1 + len(common_run))
#						print "Length is ",len(common_run)
			else:
				pass # Found a common block isolated
				if in_common_run:
					common_run.append(common_hit(lba,h))
				else:
					in_common_run = True
					common_run = [common_hit(lba,h)]
	else : # hash is not known, must be filler or tail
		if h in tail_hashes:
			if active:
				ok = is_fit (t,tail_hashes[h])
				if ok: t.end += 1
				else :
#					print "Chunk: %s at lba %d blocks %d - %d"%(t.file,t.lba,t.begin,t.end)
					print "%d;%d;%d;%s;%d;%d"%(t.lba,t.end+1-t.begin,t.lba-t.begin+t.end,t.file,t.begin,t.end)
					active = False
					frag_list.append(t)
					pass # tail that doesn't fit current chunk
			else :
				pass # isolated tail chunk
		else: #hash is not from a file or tail, must be filler
			if active:
#				print "Chunk: %s at lba %d blocks %d - %d"%(t.file,t.lba,t.begin,t.end)
				print "%d;%d;%d;%s;%d;%d"%(t.lba,t.end+1-t.begin,t.lba-t.begin+t.end,t.file,t.begin,t.end)
				active = False
				frag_list.append(t)
#			print "Filler at %d"%(lba)
			pass # need to handle filler
			if in_filler: k_filler += 1
			else:
				in_filler = True
				k_filler = 1
				filler_lba = lba
	lba += 1
	block = f.read(bs)
if active:
#	print "Chunk: %s at lba %d blocks %d - %d"%(t.file,t.lba,t.begin,t.end)
	print "%d;%d;%d;%s;%d;%d"%(t.lba,t.end+1-t.begin,t.lba-t.begin+t.end,t.file,t.begin,t.end)
	frag_list.append(t)
if in_filler:
#	print "Filler: at lba %d, %d blocks"%(filler_lba,k_filler)
	print "%d;%d;%d;Filler;;"%(filler_lba,k_filler,filler_lba-1+k_filler)
# end of image file scan		
print "<end-table>"


#print "\n%d files seen"%(len(files_seen))
files_list = list(files_seen)
files_list.sort()
at = 0
#for file in files_list:
#	if at%3 == 0:print
#	print "%-20s"%(file),
#	at += 1


print
#print "\n%d frags"%(len(frag_list))
print "<start-subhead>Fragment List for %s<end-subhead>\n"%(short_name)
print "<start-table>"
print "%d Frags for %s;;;;"%(len(frag_list),sys.argv[3].split('/')[-1])
print "File;Size;Scope;First;Last;Blocks;LBA;Thumbs"
frag_list.sort(cmp=frag_sort)
t_thumbs = 0
this_file = ""
this_lba = -1
out_of_order = set()
for frag in frag_list:
	xxx = frag.file.split('.')[-1].lower()
	delta_one(xn_frag,xxx)
	if frag.file in t_loc:
		nt = count_thumbs(frag.begin,frag.end,t_loc[frag.file])
	else: nt = 0
	t_thumbs += nt
	if this_file == frag.file:
		pass
		if this_lba > frag.lba: out_of_order.add(this_file)
	else:
		this_file = frag.file
		pass
	this_lba = frag.lba
	if int(file_summary[frag.file]) == frag.end+1-frag.begin:
		fclass = "complete"
	elif frag.begin == 0:
		fclass = "start"
	elif (frag.end+1) == int(file_summary[frag.file]):
		fclass = "end"
	else :
		fclass = "internal"
	print "%s;%s;%s;%d;%d;%d;%d;%d"%(frag.file,file_summary[frag.file],
		fclass,
		frag.begin,frag.end,frag.end+1-frag.begin,frag.lba,nt)
print "<end-table>"
print

#class file_frag(object):
#	def __init__ (s,file,size,n,n_frags):
fx = {}
n_starts = 0
n_ends = 0
for frag in frag_list:
	xxx = frag.file.split('.')[-1].lower()
	if frag.file not in fx:
		fx[frag.file] = file_frag(frag.file,file_summary[frag.file],0,0)
	fx[frag.file].n_frags += 1
	fx[frag.file].n_blocks += frag.end+1-frag.begin
#	print "Test for last: %s %s %d"%(frag.file,fx[frag.file].size,frag.end+1)
	if (frag.end + 1) == int(fx[frag.file].size):
		n_ends += 1
		delta_one(xn_end,xxx)
	if frag.begin == 0:
		n_starts += 1
		delta_one(xn_start,xxx)
k = fx.keys()
k.sort(cmp=fn_sort)
print
ext = {}
n_sectors_included = {}
n_cnc = 0 # complete and contig
n_c = 0 # complete
n_cnf = 0 # complete but fragmented
print "<start-subhead>File List for %s<end-subhead>\n"%(short_name)
print "<start-table>"
print "%d Files Present in %s;;;;"%(len(fx),image_name)
print "File;Complete;Disordered;Size;Blocks;Frags"
for frag in k:
	xxx = fx[frag].file.split('.')[-1].lower()
	if xxx in ext: ext[xxx] += 1
	else :
		ext[xxx] = 1
		n_sectors_included[xxx] = 0
	delta_one(xn_fx,xxx)
	if int(fx[frag].size) == fx[frag].n_blocks:
		star = '='
		n_c += 1
		delta_one(xn_c,xxx)
		if fx[frag].n_frags == 1:
			n_cnc += 1
			delta_one(xn_cnc,xxx)
		else:
			n_cnf += 1
			delta_one(xn_cnf,xxx)
	elif (int(fx[frag].size) - 1) == fx[frag].n_blocks: star = '<'
	else: star = ' '
	if fx[frag].file in tcount: n_t = tcount[fx[frag].file]
	else: n_t = '0'
	if fx[frag].file in out_of_order:
		odd = '*'
		delta_one (xn_disorder,xxx)
	else: odd = ''
	print "%s;%s;%s;%s;%d;%d"%(fx[frag].file,star,odd,
		fx[frag].size,fx[frag].n_blocks,fx[frag].n_frags)
	n_sectors_included[xxx] += fx[frag].n_blocks
print "<end-table>"
print

if "jpg" in ext :
	xn_thumb["jpg"] = t_thumbs

print
print "<start-subhead>Image Summary for %s<end-subhead>\n"%(short_name)
print "<start-table>"
print "Summary of %s;"%(image_name)
print "Attribute;Count"
print "N complete files;%d"%(n_c)
print "N complete contiguous files;%d"%(n_cnc)
print "N complete fragmented files;%d"%(n_cnf)
print "N complete disordered files;%d"%(len(out_of_order))
print "N incomplete files;%d"%(len(fx)-n_c)
print "N files;%d"%(len(fx))
print "N fragments;%d"%(len(frag_list))
print "N thumbnails;%d"%(t_thumbs)
print "N first File Blocks;%d"%(n_starts)
print "N last File Blocks;%d"%(n_ends)
print "N extensions;%d"%(len(ext))
print "<end-table>"

print
print "<start-table>"
print "Extensions Seen;"
print "Ext;Count"
for xxx in ext:
	print "%s;%d"%(xxx,ext[xxx])
	if xxx in xn_fx and xxx in xn_c:
		xn_partial[xxx] = xn_fx[xxx] - xn_c[xxx]
print "<end-table>"



print "<start-table>"
print "Summary by extension of %s;"%(image_name)
print "Attribute",
for xxx in ext:
	print ";%s"%(xxx),
print
ix = 0
for attr_name in ["N complete files","N complete contiguous files","N complete fragmented files",
		"N complete disordered files","N incomplete files","N files",
		"N fragments","N thumbnails","N first File Blocks","N last File Blocks"]:
	print attr_name,
	attr = attr_list[ix]
	for xxx in ext:
		if xxx in attr:
			print ";%d"%(attr[xxx]),
		else:
			print ";",
	print
	ix += 1
print "N Sectors",
for xxx in ext:
	print ";%d"%(n_sectors_included[xxx]),
print
print "<end-table>"

exit (1)


#n_c
#n_cnc
#n_cnf
#out_of_order)
#fx-n_c)
#fx)
#frag_list)
#t_thumbs
#n_starts
#n_ends
