#!/usr/bin/python
# -*- coding: utf-8 -*-
import hashlib
import sys
import os
import current_rel

#	profile the result for a set of returned files
#
#	input: tool_name_and_version File_profile Thumb_profile Image_file Image_map Result_file_list


# argv[1] -- tool-name-and-version
# Format should be NAME "_" Version

# argv[2] -- data set profile

#	Summary bn.xxx 10 blocks 5120 bytes
#	Summary lav.xxx 10 blocks 5120 bytes
#	Summary rr.xxx 6 blocks 2925 bytes
#	Summary white.xxx 10 blocks 5120 bytes
#	Summary yellow.xxx 10 blocks 5120 bytes
#	Start File bn.xxx
#	H 0 28642ba995bfd672d3c0ff159dd7b26f
#	. . .
#	H 8 76b3c06f5be8b265b5da653de9be703d
#	H 9 6d59537db71f60e6493a38533f89b9ed
#	End File yellow.xxx
#	Common 1
#	CH d9e05b1d25f1e29e65de31001feba0be 0
#	CF 0 bn.xxx 5
#	CF 0 lav.xxx 5
#	CF 0 white.xxx 5
#	CF 0 yellow.xxx 5
#	tail
#	T 204afb3ac88334fb6a56d64b2ab7c22a rr.xxx 5
#	V @(#) scan-result.py Version 1.6 created 11/18/13 at 10:04:14

# sample input	argv[3] -- thumbnails

# sample input	argv[4] -- image file

#	************ FRAG LIST ************
#	Fragment List;;;;;;
#	File;Blocks;Bytes;From;To;Size;LBA
#	image1_padded_middle.jpg;25;12289;0;24;25;91
#	image2_padded_middle.jpg;12;5634;0;11;12;126
#	image3_padded_middle-4.jpg;19;9220;0;18;19;148
#	image4_padded_middle-8.jpg;16;7688;0;15;16;177
#	image5_padded_middle-16.jpg;17;8208;0;16;17;203
#	image6_padded_middle-32.jpg;17;8224;0;16;17;230
#	

# recovered objects: argv[5:]


file_summary = {}
class noise_chunk (object):
	def __init__ (s,begin,end):
		s.begin = begin # start of noise
		s.end = end # end of noise

class known_chunk (object):
	def __str__ (s):
		return 'File:%s <%d,%d> @ LBA %d'%(s.file,s.begin,s.end,s.offset)
	def __init__ (s,file,begin,end,block):
		s.file = file	# source file
		s.begin = int(begin)	# block # in source file
		s.end = int(end)		# block # in source file
		s.offset = block	# offset within recovered file

class common_hit(object):
	def __init__ (s,lba,hash):
		s.lba = lba
		s.hash = hash
	def __str__ (s):
		return '** lba:'+str(s.lba)+' MD5: '+s.hash+' **'

class location(object):
	def __str__ (s):
		return "<%s,%d>"%(s.file,s.block)
	def __init__ (s,file,blk):
		s.file = file
		s.block = int(blk)
#		print "=== LOC Create Location (%s,%s)"%(file,blk)


class hash_set(object):
	def __init__ (s):
		s.hs = {}
#		print "+++ CREATE",type(s.hs)
	def add (s,h,loc):
		if h in s.hs:
			s.hs[h].append(loc)
		else: s.hs[h] = [loc]
#		print "=== ADD Location (%s,%s) to %s"%(loc.file,loc.block,h)
	def get (s,h):
		if h in s.hs:
#			print "Getting ",h,s.hs[h]
			return s.hs[h]
		else: return []
	def is_known (s,h):
		return h in s.hs
	def is_unique (s,h):
		if h in s.hs:
			return len(s.hs[h]) == 1
		else: return False
	def is_match (s,h,loc):
		if h in s.hs:
			for x in s.hs[h]:
				if x.file == loc.file and x.block == lic.block: return True
		return False

class summary(object):
	def __init__ (s,file,n):
		s.file = file
		s.n_blocks = n

class file_frag(object):
	def __init__ (s,file,size,n,n_frags):
		s.file = file
		s.size = size
		s.n_blocks = n
		s.n_frags = n_frags

# delta_zero and delta_one count attributes by file extension
def delta_zero (attr,ext):
	attr[ext] = 0

def delta_one (attr,ext):
	if ext in attr:
		attr[ext] += 1
	else:
		attr[ext] = 1

xn_exact = {}
xn_dup = {}
xn_complete_plus = {}
xn_trunc = {}
xn_thumbs = {}
xn_multiple = {}
xn_valid_start = {}
xn_uk = {}
xn_carved = {}
xn_cnc_missed = {}
xn_c_missed = {}
xn_valid_missed = {}

# look for match between undecided & unique
def is_fit(run,x):
	for z in x:
		if run.file == z.file and run.end == (z.block - 1):
			return True
	return False


kh = hash_set()
have_text = ['Nothing','Noise','Known','Undecided']

# see if list of undecided match to a unique
def is_decided(undecided_list,loc):
	pass
	name = loc.file
	block = loc.block
	nx = len(undecided_list)
	while nx > 0:
		nx -= 1
		block -= 1
		u = undecided_list[nx]
		ok_so_far = False
		for lll in kh.get(u[1]):
			if name == lll.file and block == lll.block:
				ok_so_far = True
		if not ok_so_far:
			return False
	return True


# check if recovered file starts with the beginning of a file
# i.e., does the recovered file have a valid start
valid_start_seen = set()
def has_valid_start(runs):
	is_valid = False
	for c in runs:
		pass
		if c[0] == run_of_known:
			chunk = c[1]
			file_name = chunk.file
			if chunk.offset == 0 and chunk.begin == 0:
				valid_start_seen.add(chunk.file)
#				print "Add %s to valid"%(chunk.file),valid_start_seen
				is_valid = True
	return is_valid

#sort list of chunks by begin block within src file
def chunk_sort (a,b):
	if a.file < b.file: return -1
	if a.file > b.file: return  1
	if a.begin < b.begin: return -1
	if a.begin > b.begin: return  1
	return 0
def is_complete(runs):
	clist = []
	flist = []
	plist = []
	complete = []
	for r in runs:
		if r[0] == run_of_known:
			clist.append(r[1])
			file = r[1].file
			if file not in flist: flist.append(file)
	if len(clist) == 0: return [[],[],[]]
	clist.sort(cmp=chunk_sort)

#	print 
	# looping over flist
	# scan the clist see if file is complete
	# make list of complete files
	# return file name list
	#
	for file_name in flist:
#		print "Scanning for ",file_name,file_summary[file_name]
		total_size = int(file_summary[file_name][0])
		look_for_start = 0
		ending_at = -1
		for chunk in clist:
			if file_name == chunk.file:
#				print chunk.file,chunk.begin,chunk.end
				if chunk.begin == look_for_start:
					look_for_start = chunk.end + 1
					ending_at = chunk.end
		if ending_at == total_size - 1:
			complete.append(file_name)
		else: plist.append(file_name)
	return [complete,flist,plist]

mapped_files = {}
class map_rec (object):
	def __init__ (s):
		s.is_complete = False # is the file complete
		s.is_contiguous = False # single chunk
		s.has_first = False # Has first file block


################################################################
#     S T A R T    H E R E                                     #
################################################################

#ver = "@(#) scan-result.py Version 1.6 created 11/18/13 at 10:04:14"
ver = "@(#) scan-result.py Version 1.6 created 11/18/13 at 10:04:14"+" (Release %s)"%(current_rel.this_rel_is)

#print "Args(%d):"%(len(sys.argv)),sys.argv
if len(sys.argv) < 6:
	print "Usage %s Tool_VER file_profile thumb_profile image_file image_map Recovered_files_list"%(sys.argv[0])
	exit(0)

map_file = sys.argv[5]
dribble = open ("/tmp/dribble-scan-results.txt","w")
#drab = open ("/tmp/drab-scan-results.txt","w")
#def debug_trace(mess):
#	drab.write(mess+'\n')
def drip(mess):
	dribble.write(mess+'\n')

drip(ver)
#debug_trace(ver)
print "<start-head>%s Carving %s Summary<end-head>\n"%(sys.argv[1],
	sys.argv[4].split('/')[-1])
short_image_name = sys.argv[4].split('/')[-1].split('_')[0]
print "Results for:",sys.argv[1]
print "Carving image:",sys.argv[4].split('/')[-1]
print "Data set:",sys.argv[2].split('/')[-1]
print
print "Analysis script:",ver
drip( "Results for:"+sys.argv[1])
drip( "Carving image:"+sys.argv[4].split('/')[-1])
drip( "Data set:"+sys.argv[2].split('/')[-1])
drip("Map file:"+map_file)


bs = 512
common_hashes = {}
tail_hashes = {}
f_list = []

tool_name = sys.argv[1]
image_file_name = sys.argv[4].split('/')[-1]
if tool_name.find('_') == -1: tool_name = sys.argv[1]+"_missing"
dfd = open("/tmp/Detail-"+sys.argv[4].split('/')[-1].split('.')[0]+"-"+tool_name+'.txt',"w")
#sfd = open("/tmp/brief-"+tool_name.split('_')[0]+'.txt',"w")

dfd.write ("<start-head>%s Carving %s Details<end-head>\n\n"%(sys.argv[1],
	sys.argv[4].split('/')[-1]))
dfd.write("Detailed Results for: "+sys.argv[1]+'\n')
dfd.write("Carving image: "+sys.argv[4].split('/')[-1]+'\n')
dfd.write("Data set: "+sys.argv[2].split('/')[-1]+'\n')
dfd.write("Map file: "+map_file+'\n\n')
dfd.write("Analysis script: "+ver+'\n\n')
dfd.write ("<start-subhead>Recovered Content by File for %s<end-subhead>\n\n"%(
	short_image_name))
dfd.write("<start-table>"+'\n')
dfd.write("Result Details for %s on %s;;;;;"%(tool_name,image_file_name)+'\n')
dfd.write("Recovered;Content;From;Offset;First;Last;Size"+'\n')

################################################################
#     R E A D    H A S H    S E T S                            #
################################################################

db = open(sys.argv[2],"rt")
for line in db:
	line = line.strip('\n')
	fields = line.split(' ')
	if fields[0] == "Summary":
		fn = fields[1]
		blks = fields[2]
		bytes = fields[4]
		file_summary[fn] = [blks,bytes]
	elif fields[0] == "Start":
		current_file = fields[2]
	elif fields[0] == "H":
		h = fields[2]
		blk = fields[1]
		loc = location(current_file,blk)
		kh.add(h,loc)
	elif fields[0] == "CH":
		h = fields[1]
		if h in common_hashes:
			pass
		else:
			common_hashes[h] = fields[2]
	elif fields[0] == "CF":
		f_list.append(fields[1:])
	elif fields[0] == "T":
		tail_hashes[fields[1]] = fields[2:]
		kh.add(h,location(fields[2],fields[3]))



#for h in kh.hs:
#	print h,
#	for lx in kh.get(h):
#		print lx,
##		print h,lx.file,lx.block
#	print
#print "done"
#xit(0)


#for h in unique_hashes:
#	print h,unique_hashes[h]
#print "common"
#for h in common_hashes:
#	print h,common_hashes[h]
#print "tail"
#for h in tail_hashes:
#	print h,tail_hashes[h]
#
######################################################
# read thumbnail profile database

################################################################
#     R E A D    T H U M B N A I L    P R O F I L E            #
################################################################

t = {}
db = open(sys.argv[3],"rb")
line = db.readline()
#print "First thumb line:",len(line),line
while len(line):
	line = line.strip('\n')
	fields = line.split(' ')
	if (fields[0] != 'XT'):
		t[fields[8]] = [fields[3],fields[5:8]]
	line = db.readline()
db.close()


xattr = []
n_sectors = []
map_fd = open(map_file,"rt")
state = "nothing"
sector_state = False
for line in map_fd:
	line = line.strip('\n')
#	print line
	if line.find('Summary by ext') != -1:
		sector_state = True
	if sector_state:
		if line.find('Attribute') != -1:
			xattr = line.split(';')
		if line.find('N Sector') != -1:
			n_sectors = line.split(';')

	if line.find('Frags for ') != -1:
		state = "frag tab"
#		debug_trace("In Frag Tab ========")
	elif line.find('Files Present ') != -1:
		state = "files tab"
#		debug_trace("In Files Tab ========")
	elif line.find('end-table') != -1:
		state = "nothing"
	else:
		fields = line.split(';')
		if state != "nothing":
			file_name = fields[0]
			if file_name != 'File':
#				print len(fields),file_name,fields
				if file_name not in mapped_files:
					mapped_files[file_name] = map_rec()
				if state == "frag tab":
					pass
#					debug_trace(str(fields))
					if len(fields) > 3:
#						print "Check first:",fields[2]
						if fields[3] == '0': mapped_files[file_name].has_first = True
				elif state == "files tab":
					pass
#					debug_trace(str(fields))
					if len(fields) > 5:
						if fields[1] == '=': mapped_files[file_name].is_complete = True
						if fields[5] == '1': mapped_files[file_name].is_contiguous = True
#
#	scan the recovered files #########################
#
#print "================================"
#title = sys.argv[4].split('/')[-2]+" carving "+sys.argv[3].split('/')[-1]
title = sys.argv[1]
drip ("Testing: "+tool_name)
print "<start-subhead>Recovered Attributes by File for %s<end-subhead>\n"%(short_image_name)
print "<start-table>"
print "Results for",title,";;;;;;;"
#print "File;Size;Multi;Content from . . .;Com;Noise;All"
print "File;Tmb;Cmplt;Part;Cntrb;Noise;Undec;Disordered"
#print "********** ZERO Totals ************"
n_carved = 0
n_valid_start = 0
n_dup = 0
n_exact = 0
n_trunc = 0
n_first_valid = 0
n_thumbs = 0
n_multiple = 0
n_complete = 0
n_complete_plus = 0
n_uk = 0
ext = {}
exact_seen = []
files_completed = {}

################################################################
#     S T A R T    S C A N                                     #
################################################################

def fn_sort (a,b):
	aa = a.split('.')
	bb = b.split('.')
	if aa[1].lower() < bb[1].lower(): return -1
	if aa[1].lower() > bb[1].lower(): return  1
	if aa[0].lower() < bb[0].lower(): return -1
	if aa[0].lower() > bb[0].lower(): return  1
	return 0

#file_name_list = sys.argv[6:]
#print "============================"
#print file_name_list
#print "============================"
#print file_name_list
#print "============================"

n_blocks_recovered = {} # track counts for precision & recall
known_blocks_recovered = {}
all_blocks_recovered = set()


#n_blocks_recovered = {} count by file type of any blocks in recovered files
#known_blocks_recovered = {} set of known hashes recovered for each file type
#all_blocks_recovered = set() a set of all blocks recovered (eliminates dups across
# recovered files)

file_name_dir = sys.argv[6]
file_name_list = []
for line in open(sys.argv[7],"r"):
	file_name_list.append(file_name_dir+'/'+line.strip('\n'))
#drip("file_list")
#for fnx in file_name_list: drip (fnx)
#drip("End file_list")
file_name_list.sort(cmp=fn_sort)

#for file_name in sys.argv[6:]:
for file_name in file_name_list:
	f = open(file_name,"rb")
	drip(file_name.strip('\n').split('/')[-1])
#	dfd.write("%s;;;;;"%(file_name.strip('\n').split('/')[-1])+'\n')
	xxx = file_name.split('.')[-1].lower()
	drip("EXT = "+xxx)
	if xxx == 'tiff': xxx = 'tif'
	if xxx == 'jpeg': xxx = 'jpg'
	if xxx in ext:
		ext[xxx] += 1
	else:
		ext[xxx] = 1
		n_blocks_recovered[xxx] = 0
		known_blocks_recovered[xxx] = set()
	n_carved += 1
	delta_one(xn_carved,xxx)
	b = f.read(512)
	offset = 0
	if len(b) > 5:
		if b[0:5] == 'Equip':
			xxx = 'Exif'
			if xxx in ext:
				ext[xxx] += 1
			else:
				ext[xxx] = 1
				n_blocks_recovered[xxx] = 0
				known_blocks_recovered[xxx] = set()
	thf = hashlib.md5()
	seen = {}
	files_seen = {}
	n_unique = 0
	runs = []
	n_common = 0
	n_unknown = 0
	n_bytes = 0
	n_blocks = 0
	n_short = 0
	n_mcat = 0

	run_of_noise = 1
	run_of_known = 2
	run_of_undecided = 3
	run_of_nothing = 0
	have = run_of_nothing

	while len(b) > 0:
		n_blocks += 1
		n_blocks_recovered[xxx] += 1
		n_bytes += len(b)
		hf = hashlib.md5()
		hf.update(b)
		thf.update(b)
		hv = hf.hexdigest()
		see = 'noise'
# classify current block
		if kh.is_known(hv):
			if len(kh.get(hv)) == 1: see = 'Unique'
			else: see = 'Undecided'
			if hv not in all_blocks_recovered:
				all_blocks_recovered.add(hv)
				could_be = kh.get(hv)
				if len (could_be) == 1:
					www = could_be[0].file.split('.')[1].lower()
					if www == 'tiff': www = 'tif'
					if www == 'jpeg': www = 'jpg'
					if xxx == www:
						known_blocks_recovered[xxx].add(hv)
#				known_blocks_recovered[xxx].add(hv)
		drip("offset %5d have %s, this %s, hash: %s"%(offset,have_text[have],see,hv))

################################################################
#       N O T H I N G                                          #
################################################################

		if have == run_of_nothing:
			pass
			if kh.is_known(hv):
				pass # this block is known
				if kh.is_unique(hv):
					pass # this block is known & unique
					known = known_chunk (kh.get(hv)[0].file,
						kh.get(hv)[0].block,
						kh.get(hv)[0].block,offset)
					have = run_of_known
				else:
					pass # this block is known but undecided
					undecided_list = []
					undecided_list.append([offset,hv])
					have = run_of_undecided
			else:
				pass # this block is noise
				noise = noise_chunk(offset,offset)
				have = run_of_noise

################################################################
#       N O I S E                                              #
################################################################
		elif have == run_of_noise:
			pass
			if kh.is_known(hv):
				pass # this block is known
				runs.append ([run_of_noise,noise])
				if kh.is_unique(hv):
					pass # this block is known & unique
					have = run_of_known
					known = known_chunk (kh.get(hv)[0].file,
						kh.get(hv)[0].block,
						kh.get(hv)[0].block,offset)
				else:
					pass # this block is known but undecided
					have = run_of_undecided
					undecided_list = []
					undecided_list.append([offset,hv])
			else:
				pass # this block is noise
				noise.end += 1

################################################################
#       K N O W N                                              #
################################################################
		elif have == run_of_known:
			pass
			if kh.is_known(hv):
				pass # this block is known
				if is_fit (known,kh.get(hv)):
					pass # merge this block into known
					known.end += 1
				else:
					pass # this block is known but not a fit
					# might be (1) unique or (2) undecided
					runs.append([run_of_known,known])
					if kh.is_unique(hv):
						pass # block doesn't fit & is unique
						known = known_chunk (kh.get(hv)[0].file,
							kh.get(hv)[0].block,
							kh.get(hv)[0].block,offset)
					else:
						pass # block doesn't fit & is undecided
						have = run_of_undecided
						undecided_list = []
						undecided_list.append([offset,hv])
			else:
				pass # this block is noise
				runs.append([run_of_known,known])
				noise = noise_chunk(offset,offset)
				have = run_of_noise

################################################################
#       U N D E C I D E D                                      #
################################################################
		elif have == run_of_undecided:
			pass
			if kh.is_known(hv):
				pass # this block is known
				if kh.is_unique(hv):
					pass # this block is known & unique
					if is_decided(undecided_list,kh.get(hv)[0]):
						pass
						known = known_chunk (kh.get(hv)[0].file,
							kh.get(hv)[0].block - len(undecided_list),
							kh.get(hv)[0].block,offset - len(undecided_list))
						have = run_of_known
					else:
						pass # dosen't fit
#						print "Emit 1 und"
						runs.append([run_of_undecided,undecided_list])
						known = known_chunk (kh.get(hv)[0].file,
							kh.get(hv)[0].block,
							kh.get(hv)[0].block,offset)
						have = run_of_known
				else:
					pass # this block is known but undecided
#					print "Emit 2 und"
					undecided_list.append([offset,hv])
			else:
				pass # this block is noise
				runs.append([run_of_undecided,undecided_list])
				noise = noise_chunk(offset,offset)
				have = run_of_noise

	
		b = f.read(512)
		offset += 1
	if have == run_of_known:
#		print "KNOWN is:",known
		runs.append([run_of_known,known])
	elif have == run_of_noise:
		runs.append([run_of_noise,noise])
	elif have == run_of_undecided:
		runs.append([run_of_undecided,undecided_list])
#	print file_summary.keys()
	drip(file_name.split('/')[-1])
	drip("%d runs"%(len(runs)))
	for x in runs:
		drip( have_text[x[0]])
		if x[0] == 1:
			drip( have_text[x[0]]+"%d blocks of noise"%(x[1].end + 1 - x[1].begin))
		elif x[0] == 2:
			fs = x[1].file
			drip(have_text[x[0]]+str(x[1])+" File len "+str(file_summary[fs][0]))
		elif x[0] == 3:
			drip(have_text[x[0]]+str(len(undecided_list)))
		elif x[0] == 0:
			pass
	drip("end "+file_name.split('/')[-1])

################################################################
#       A N A L Y Z E    R E C O V E R E D    F I L E          #
################################################################
#	print "Analyze "+file_name.split('/')[-1]
	thv = thf.hexdigest()
	if thv in t: # found an extracted thumb
		dfd.write("%s;Thumb;;;;"%(file_name.strip('\n').split('/')[-1])+'\n')
	else:
		dfd.write("%s;;;;;"%(file_name.strip('\n').split('/')[-1])+'\n')
	this_is_thumb = ""
	has_noise = False
	complete_files = is_complete(runs)
	if thv in t: # found an extracted thumb
		pass
		n_thumbs += 1
		delta_one(xn_thumbs,xxx)
		this_is_thumb = "*"
	elif len(runs) == 1:
		run_type = runs[0][0]
		chunk = runs[0][1] # chunk is one of 3 possible
		if run_type == run_of_known:
			pass
			if has_valid_start(runs):
				n_valid_start += 1
				delta_one(xn_valid_start,xxx)
			chunk_name = chunk.file
			file_size = int(file_summary[chunk_name][0])
			recovered_size = chunk.end+1-chunk.begin
			if file_size == recovered_size:
				if chunk_name in exact_seen:
					n_dup += 1
					delta_one(xn_dup,xxx)
				else:
					n_exact += 1
					delta_one(xn_exact,xxx)
					exact_seen.append(chunk_name)
			else:
				n_trunc += 1
				delta_one(xn_trunc,xxx)
#				if has_valid_start(runs):
#					n_valid_start += 1
		elif run_type == run_of_undecided:
			pass
		else: # noise
			pass
			has_noise = True
	else: # len(runs) > 1
		if has_valid_start(runs):
			n_valid_start += 1
			delta_one(xn_valid_start,xxx)


# complete_files:
#	[0] list of complete files
# 	[1] list of contributing files
#	[2] list of partials
		complete_files = is_complete(runs)
		pass
		if len(complete_files) != 0:
#			print "IS COMPLETE **************",complete_files[0],complete_files[2]
			if len(complete_files[0]) > 0:
				n_complete_plus += 1
				delta_one(xn_complete_plus,xxx)
			if len(complete_files[1]) > 0:
				n_multiple += 1
				delta_one(xn_multiple,xxx)
#	Report results for carved file
	k_noise = 0
	k_undecided = 0
	order_list = {}
	out_cnt = 0
	for c in runs:
		if this_is_thumb == '*': break
		if c[0] == run_of_noise:
			k_noise += c[1].end+1-c[1].begin
			dfd.write(";%s;;%d;0;%d;%d"%(have_text[c[0]],c[1].begin,
				c[1].end+1-c[1].begin,c[1].end+1-c[1].begin)+'\n')
			has_noise = True
		if c[0] == run_of_undecided: k_undecided += len(c[1])
		if c[0] == run_of_known:
			pass
			dfd.write(";%s;%s;%d;%d;%d;%d"%(have_text[c[0]],c[1].file,
				c[1].offset,c[1].begin,c[1].end,c[1].end+1-c[1].begin)+'\n')
			fname = c[1].file
			coffset = c[1].begin
			if fname in order_list:
				if coffset < order_list[fname]:
					out_cnt += 1
				order_list[fname] = coffset
			else:
				order_list[fname] = coffset
	k_c = len(complete_files[0])
	k_t = len(complete_files[1])
	k_p = len(complete_files[2])
	if has_noise:
		n_uk += 1
		delta_one(xn_uk,xxx)
	f.close()
#print "File;Size;Multi;Content from . . .;Com;Noise;All"
	print "%s;%s;%d;%d;%d;%d;%d;%d"%(file_name.split('/')[-1],this_is_thumb,k_c,k_p,k_t,k_noise,k_undecided,out_cnt)
	
print '<end-table>'


n_cnc_missed = 0
n_c_missed = 0
n_valid_missed = 0
for fn in mapped_files:
	mr = mapped_files[fn]
	if mr.is_complete and mr.is_contiguous and (fn not in exact_seen):
		n_cnc_missed += 1
		delta_one(xn_cnc_missed,xxx)
	if mr.is_complete and (fn not in exact_seen):
		n_c_missed += 1
		delta_one(xn_c_missed,xxx)
	if mr.has_first and (fn not in valid_start_seen):
		n_valid_missed += 1
		delta_one(xn_valid_missed,xxx)
#	dfd.write("%s;%s;%s;%s;%s\n"%(fn,mr.is_complete,mr.is_contiguous,mr.has_first,
#		fn in exact_seen))



n_extra = 0
print '\n'
print "<start-subhead>Results Summary for %s<end-subhead>\n"%(short_image_name)
print '<start-table>'
print "Results Summary;"
print "Attribute;Count"
print "N Exact Match;",n_exact
print "N Redundant Match;",n_dup
print "N Complete Plus;",n_complete_plus
print "N Incomplete;",n_trunc
print "N Thumbs;",n_thumbs
print "N Multiple;",n_multiple
print "N Valid Start;",n_valid_start
print "N With Some Noise;",n_uk
print "N Carved;",n_carved
print "N Complete & Contig missed;",n_cnc_missed
print "N Complete missed;",n_c_missed
print "N Valid start missed;",n_valid_missed
for xxx in ext:
	print xxx,';',ext[xxx]
print '<end-table>'
dfd.write("<end-table>"+'\n')
dfd.write ("<start-subhead>Image Content Attributes by File %s<end-subhead>\n\n"%(
	short_image_name))
dfd.write("<start-table>"+'\n')
dfd.write("Image File Summary for %s;;;;;"%(map_file.split('/')[-1])+'\n')
dfd.write("File;Complete;Contiguous;Has First Block;Exact Rec;First Rec"+'\n')
f_keys = mapped_files.keys()
f_keys.sort(cmp=fn_sort)
#for fn in mapped_files:
for fn in f_keys:
	mr = mapped_files[fn]
	dfd.write("%s;%s;%s;%s;%s;%s\n"%(fn,mr.is_complete,mr.is_contiguous,mr.has_first,
		(fn in exact_seen),(fn in valid_start_seen)))
	
dfd.write("<end-table>"+'\n')
#dfd.write("\n\n%d starts seen\n"%(len(valid_start_seen)))
#for fn in valid_start_seen:
#	dfd.write("%s\n"%(fn))

#[xn_exact, xn_dup, xn_complete_plus, xn_trunc, xn_thumbs,
#xn_multiple, xn_valid_start, xn_uk, xn_carved, xn_cnc_missed,
#xn_c_missed, xn_valid_missed]


dfd.write ("<start-subhead>Results Summary by File Extension for %s<end-subhead>\n\n"
	%(short_image_name))
dfd.write("<start-table>"+'\n')
dfd.write('Results Summary by file Extension%s\n'%(';'*len(ext)))
dfd.write("Attribute")
for xxx in ext:
	dfd.write(";%s"%(xxx))
dfd.write('\n')
ix = 0
for attr_name in ["N Exact Match", "N Redundant Match", "N Complete Plus",
	"N Incomplete", "N Thumbs", "N Multiple", "N Valid Start",
	"N With Some Noise", "N Carved", "N Complete & Contig missed",
	"N Complete missed", "N Valid start missed"]:
	attr = [xn_exact, xn_dup, xn_complete_plus, xn_trunc, xn_thumbs,
		xn_multiple, xn_valid_start, xn_uk, xn_carved, xn_cnc_missed,
		xn_c_missed, xn_valid_missed][ix]
	
	dfd.write(attr_name)
	for xxx in ext:
		value = ""
		if xxx in attr:
			value = attr[xxx]
		dfd.write(";"+str(value))
	dfd.write('\n')
	ix += 1
dfd.write("<end-table>"+'\n')
r_n_r = open ("/tmp/r-and-r.txt","a")
print "\n"
print "<start-subhead>Recovered and Relevant Return Scores<end-subhead>"
print
print "<start-table>"
print "Relevant and Recovered Data scores for %s on %s;;;;;;"%(tool_name,image_file_name)
print "Extension;Recovered and Relevant;Recovered;P;Relevant;R;F"
#r_n_r.write("<start-table>"+'\n')
#r_n_r.write("Relevant and Recovered Data scores Summary"+'\n')
#r_n_r.write("Test Case;Recovered and Relevant;Recovered;P;Relevant;R;F"+'\n')
t = 0
ts = 0
ti = 0
xattr = [ex.strip() for ex in xattr]
if 'tiff' in xattr:
	zzz = xattr.index('tiff')
	xattr[zzz] = 'tif'
for xxx in known_blocks_recovered:
	if n_blocks_recovered[xxx] != 0:
		precision = (float(len(known_blocks_recovered[xxx]))/
			float(n_blocks_recovered[xxx]))
	else: precision = 0.0
	recall = 0.0
	ns_cnt = '0'
	kbr = 0
	drip(xxx)
	if xxx in xattr:
		zzz = xattr.index(xxx)
		drip("%s %d %s"%(xxx,zzz,n_sectors[zzz]))
		if int(n_sectors[zzz]) != 0:
			recall = (float(len(known_blocks_recovered[xxx]))/
				float(n_sectors[zzz]))
		else: recall = 0.0
		ns_cnt = n_sectors[zzz]
		kbr = len(known_blocks_recovered[xxx])
#		print ";%s;%.3f"%(n_sectors[zzz],recall),
#	else: print ';;',
	if n_blocks_recovered[xxx] != 0:
		p1 = float(len(known_blocks_recovered[xxx]))/ float(n_blocks_recovered[xxx])
	else : p1 = 0.0
	if (precision+recall) == 0: f1 = 0.0
	else: f1 = (2.0*(precision*recall)/(precision+recall))
	print "%s;%d;%d;%.3f;%s;%.3f;%.3f"%(xxx,len(known_blocks_recovered[xxx]),
		n_blocks_recovered[xxx],p1, ns_cnt,recall,f1)
#	print ";%7.3f"%(2.0*(precision*recall)/(precision+recall))
	ts += int(ns_cnt)
	ti += kbr
	t += n_blocks_recovered[xxx]
if ts == 0:
	recall = 0.0
else:
	recall = float(ti)/float(ts)
if t == 0:
	precision = 0.0
else:
	precision = float(ti)/float(t)
if recall+precision < 0.001: f1 = 0.0
else: f1 = 2.0*(precision*recall)/(precision+recall)

drip("ts %d ti %d t %d"%(ts,ti,t))
print "Total;%d;%d;%.3f;%d;%.3f;%.3f"%(len(all_blocks_recovered),
	t,precision, ts,recall,f1)
r_n_r.write("%s;%d;%d;%.3f;%d;%.3f;%.3f"%(image_file_name.split('_')[0],
	len(all_blocks_recovered),
	t,precision, ts,recall,f1) +'\n')
#print "Total;%d;%d;%.3f;%d;%.3f;%.3f"%(len(all_blocks_recovered),
#	t,len(all_blocks_recovered)/float(t),
#	ts,recall,f1)
print "<end-table>"
drip("Normal exit")
#r_n_r.write("<end-table>"+'\n')
exit (0)
